<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用户试卷主键" prop="examUserId">
        <el-input
          v-model="queryParams.examUserId"
          placeholder="请输入用户试卷主键"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="问题主键" prop="questionId">
        <el-input
          v-model="queryParams.questionId"
          placeholder="请输入问题主键"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="用户答案" prop="answers">
        <el-input
          v-model="queryParams.answers"
          placeholder="请输入用户答案"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="排序" prop="sortBy">
        <el-input
          v-model="queryParams.sortBy"
          placeholder="请输入排序"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="答题结果" prop="useRes">
        <el-input
          v-model="queryParams.useRes"
          placeholder="请输入答题结果"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="答题得分" prop="useMark">
        <el-input
          v-model="queryParams.useMark"
          placeholder="请输入答题得分"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['manage:busExamUserResult:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['manage:busExamUserResult:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['manage:busExamUserResult:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['manage:busExamUserResult:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="busExamUserResultList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="用户试卷主键" align="center" prop="examUserId" />
      <el-table-column label="问题主键" align="center" prop="questionId" />
      <el-table-column label="用户答案" align="center" prop="answers" />
      <el-table-column label="排序" align="center" prop="sortBy" />
      <el-table-column label="答题结果" align="center" prop="useRes" />
      <el-table-column label="答题得分" align="center" prop="useMark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['manage:busExamUserResult:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['manage:busExamUserResult:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改用户试卷结果对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="busExamUserResultRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="用户试卷主键" prop="examUserId">
          <el-input v-model="form.examUserId" placeholder="请输入用户试卷主键" />
        </el-form-item>
        <el-form-item label="问题主键" prop="questionId">
          <el-input v-model="form.questionId" placeholder="请输入问题主键" />
        </el-form-item>
        <el-form-item label="用户答案" prop="answers">
          <el-input v-model="form.answers" placeholder="请输入用户答案" />
        </el-form-item>
        <el-form-item label="排序" prop="sortBy">
          <el-input v-model="form.sortBy" placeholder="请输入排序" />
        </el-form-item>
        <el-form-item label="答题结果" prop="useRes">
          <el-input v-model="form.useRes" placeholder="请输入答题结果" />
        </el-form-item>
        <el-form-item label="答题得分" prop="useMark">
          <el-input v-model="form.useMark" placeholder="请输入答题得分" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="BusExamUserResult">
import { listBusExamUserResult, getBusExamUserResult, delBusExamUserResult, addBusExamUserResult, updateBusExamUserResult } from "@/api/manage/busExamUserResult";

const { proxy } = getCurrentInstance();

const busExamUserResultList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    examUserId: null,
    questionId: null,
    answers: null,
    sortBy: null,
    useRes: null,
    useMark: null
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询用户试卷结果列表 */
function getList() {
  loading.value = true;
  listBusExamUserResult(queryParams.value).then(response => {
    busExamUserResultList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    examUserId: null,
    questionId: null,
    answers: null,
    sortBy: null,
    useRes: null,
    useMark: null
  };
  proxy.resetForm("busExamUserResultRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.examUserId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加用户试卷结果";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _examUserId = row.examUserId || ids.value
  getBusExamUserResult(_examUserId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改用户试卷结果";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["busExamUserResultRef"].validate(valid => {
    if (valid) {
      if (form.value.examUserId != null) {
        updateBusExamUserResult(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBusExamUserResult(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _examUserIds = row.examUserId || ids.value;
  proxy.$modal.confirm('是否确认删除用户试卷结果编号为"' + _examUserIds + '"的数据项？').then(function() {
    return delBusExamUserResult(_examUserIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('manage/busExamUserResult/export', {
    ...queryParams.value
  }, `busExamUserResult_${new Date().getTime()}.xlsx`)
}

getList();
</script>
